#define min(a,b)	(((a) < (b)) ? (a) : (b))

/* returns position of patch modification if done, -1 if not found or pending */
int dopatch(buffer, buflen, original, match, patch, patchlen, npend)

char *buffer;	/* buffer to patch */
int buflen;	/* length of buffer */
char *original;	/* text to locate */
char *match;	/* true if match important, first value assumed true */
char *patch;	/* text to replace */
int patchlen;	/* length of original, match, patch */
int *npend;	/* number of matched chars at end, or patch length */
{
  int i,j;
  char *sbuf, *sorg, *smat;
  int buflen1,patchstart,patchend,testlen;

  buflen1 = buflen;		/* save original buffer length */
  while (buflen) {
    if (*buffer == *original) {	/* first character matches, see if more */
      sbuf = buffer;
      sorg = original;
      smat = match;
      testlen = min(patchlen,buflen);
      for (i=1; (i <= testlen); i++,smat++)
        if ( (*(sbuf++) != *(sorg++)) && *smat )
          goto endwhile;

      /* we have a match ! */
      if (i < patchlen) {	/* pending at end */
        *npend = i;
        return -1;
      } else {
        /* do patch */
        patchstart = 0;
        patchend = -1;
        for (i=1; (i <= patchlen); i++,patch++,buffer++)
          if( *(original++) != *patch ) {
            *buffer = *patch;
            if (patchstart == 0) patchstart = i;
            patchend = i;
          }
        *npend = patchend - patchstart + 1;
        return (patchstart + (buflen1 - buflen) );	/*zero based*/
      }
    }
endwhile:
    buffer++;
    buflen--;
  }
  /* no matches */
  *npend = 0;
  return -1;
}
