#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#define BUFSIZE 16384

#ifndef O_BINARY
#define O_BINARY 0
#endif
#include "colorcod.h"

int main(argc, argv)
int argc;
char **argv;
{
  char *buffer;
  int patchlen,npend,i,j,k,l,buflen;
  int fil,nread,nfound;
  long where;
  FILE *fp;
  char *wildname, *dire, *cp, *imagename;
  char nbuf[3],set;
  char *original, *match;

  original = orig1;
  match = match1;
  patchlen = sizeof(orig1);
  buffer = (char *)malloc(BUFSIZE + patchlen);
  nfound = 0;

  argv++;
  argc--;
  if(argc != 1 && argc != 3){
    printf("Usage: setcolor editor-image [primary-color] [secondary-color]\n\n\
If colors not specified, current colors displayed.\n\n\
Color format:  Blink   Background   Intense   Letters\n\
 (bit nums)      7      6  5  4        3      2  1  0\n\n\
Value  Color   (intense)\n\
  0    Black   Grey\n\
  1    Blue    Light Blue\n\
  2    Green   Light Green\n\
  3    Cyan    Light Cyan\n\
  4    Red     Light Red\n\
  5    Magenta Light Magenta\n\
  6    Brown   Yellow\n\
  7    White   Intense White\n\n\
For example, intense white on blue background would be 0x1f\n\n\
A nice combination would be:\n\
C:\\EDC> setcolor edc.exe 0x1f 0x70\n");
    return 1;
  }
  npend = 0;
  fil = open(argv[0], O_RDWR|O_BINARY, 0);
  if(fil < 0) {
    fprintf(stderr, "Error opening %s\n",argv[0]);
    return 2;
  }
  imagename = argv[0];
  argv++;
  argc--;
  set = 0;
  if(argc){
    sscanf(argv[0],"0x%x",&i);
    nbuf[1] = i;
    sscanf(argv[1],"0x%x",&i);
    nbuf[0] = i;
    set = 1;
  }
  where = 0;
  nread = read(fil, buffer, BUFSIZE);
  while (nread > 0) {
    buflen = nread + npend;
    i = dopatch(buffer, buflen, original, match, original, patchlen, &npend);
    if (i >= 0) {
      where = lseek(fil, (long)where+i, SEEK_SET);
      /* printf("Patch found at offset %ld\n",(long)where+i); */
      if(set) {
        original[4] = nbuf[0];
        original[9] = nbuf[1];
        write(fil, original, patchlen);
      } else {
        read(fil, original, patchlen);
        printf("Primary color:   0x%x\nSecondary color: 0x%x\n",
        	(int)original[9],(int)original[4]);
      }
      npend = 0;
      nfound++;
    }
    if (npend) memcpy(buffer, buffer+buflen-npend, npend);
    where = lseek(fil, 0L, SEEK_CUR) - npend;
    nread = read(fil, buffer+npend, BUFSIZE);
  }
  close(fil);
  /* fprintf(stderr,"Bytes checked: %ld\n",(long)where); */
  if(nfound)
    return 0;
  fprintf(stderr,"Color code not found in %s\n",imagename);
  return 4;
}
